'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _browserSync = require('browser-sync');

var _browserSync2 = _interopRequireDefault(_browserSync);

var _lodashMerge = require('lodash/merge');

var _lodashMerge2 = _interopRequireDefault(_lodashMerge);

var _gulpNotify = require('gulp-notify');

var _gulpNotify2 = _interopRequireDefault(_gulpNotify);

var TaskMaker = (function () {
	function TaskMaker(gulp) {
		_classCallCheck(this, TaskMaker);

		this.gulp = gulp;
		this.globalBrowserSyncs = {};
	}

	_createClass(TaskMaker, [{
		key: 'createBrowserSync',
		value: function createBrowserSync(name) {
			var bs = _browserSync2['default'].create(name);
			this.globalBrowserSyncs[name] = bs;
			return bs;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(name) {
			var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

			name = this._resolveAliases(name);

			if (!options.taskMaker) {
				options.taskMaker = this;
			}
			if (!options.taskName) {
				options.taskName = name;
			}
			if (!options.taskDeps) {
				options.taskDeps = [];
			}
			if (!options.globalBrowserSyncs) {
				options.globalBrowserSyncs = this.globalBrowserSyncs;
			}
			if (!options.defaultErrorHandler) {
				options.defaultErrorHandler = {
					errorHandler: _gulpNotify2['default'].onError('<%= error.message %>')
				};
			}

			try {
				var taskClass = require('./tasks/' + name + '.js');
				new taskClass().setOptions(options).defineTask(this.gulp);

				if (options.watchTask && options.src) {
					var newOptions = (0, _lodashMerge2['default'])({ tasks: [options.taskName] }, options);
					newOptions.taskName = 'watch-' + options.taskName;
					var watchTask = require('./tasks/watch.js');
					new watchTask().setOptions(newOptions).defineTask(this.gulp);
					_gulpUtil2['default'].log('Created watch task: ' + newOptions.taskName);
				}
			} catch (e) {
				_gulpUtil2['default'].log(_gulpUtil2['default'].colors.red(e));
				throw e;
			}
		}

		/**
   * The author was stupid and made a bad naming decision.
   *
   * @private
   */
	}, {
		key: '_resolveAliases',
		value: function _resolveAliases(name) {
			if (name === 'es6') {
				_gulpUtil2['default'].log(_gulpUtil2['default'].colors.magenta('Please rename the es6 task to babel'));
				return 'babel';
			}
			return name;
		}
	}]);

	return TaskMaker;
})();

exports['default'] = TaskMaker;
module.exports = exports['default'];