'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _gulpPlumber = require('gulp-plumber');

var _gulpPlumber2 = _interopRequireDefault(_gulpPlumber);

var _gulpCached = require('gulp-cached');

var _gulpCached2 = _interopRequireDefault(_gulpCached);

var _gulpChanged = require('gulp-changed');

var _gulpChanged2 = _interopRequireDefault(_gulpChanged);

var _gulpSourcemaps = require('gulp-sourcemaps');

var _gulpSourcemaps2 = _interopRequireDefault(_gulpSourcemaps);

var _gulpCoffee = require('gulp-coffee');

var _gulpCoffee2 = _interopRequireDefault(_gulpCoffee);

var _gulpBabel = require('gulp-babel');

var _gulpBabel2 = _interopRequireDefault(_gulpBabel);

var _gulpUglify = require('gulp-uglify');

var _gulpUglify2 = _interopRequireDefault(_gulpUglify);

var _gulpNgAnnotate = require('gulp-ng-annotate');

var _gulpNgAnnotate2 = _interopRequireDefault(_gulpNgAnnotate);

var _gulpRename = require('gulp-rename');

var _gulpRename2 = _interopRequireDefault(_gulpRename);

var _gulpChmod = require('gulp-chmod');

var _gulpChmod2 = _interopRequireDefault(_gulpChmod);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var _lodashMerge = require('lodash/merge');

var _lodashMerge2 = _interopRequireDefault(_lodashMerge);

var _lodashForEach = require('lodash/forEach');

var _lodashForEach2 = _interopRequireDefault(_lodashForEach);

var defaultCompilerOptions = {
	comments: false,
	compact: false
};

var defaultUglifyOptions = {
	mangle: true
};

var BabelTask = (function () {
	function BabelTask() {
		_classCallCheck(this, BabelTask);
	}

	_createClass(BabelTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if ((0, _lodashIsUndefined2['default'])(this.options.src)) {
				throw new Error('BabelTask: src is missing from configuration!');
			}

			if ((0, _lodashIsUndefined2['default'])(this.options.dest)) {
				throw new Error('BabelTask: dest is missing from configuration!');
			}

			if (this.options.notify) {
				this.options.plumberOptions = this.options.defaultErrorHandler;
			}

			// Handle defaults
			this.options.compilerOptions = (0, _lodashMerge2['default'])({}, defaultCompilerOptions, this.options.compilerOptions);
			this.options.coffeeOptions = (0, _lodashMerge2['default'])({ bare: true }, this.options.coffeeOptions);
			this.options.ngAnnotateOptions = (0, _lodashMerge2['default'])({ sourceMap: true }, this.options.ngAnnotateOptions);
			this.options.plumberOptions = (0, _lodashMerge2['default'])({}, this.options.plumberOptions);
			this.options.uglifyOptions = (0, _lodashMerge2['default'])({}, defaultUglifyOptions, this.options.uglifyOptions);

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var options = this.options;

			gulp.task(options.taskName, options.taskDeps, function () {
				var chain = gulp.src(options.src);

				chain = chain.pipe((0, _gulpCached2['default'])(options.taskName)).pipe((0, _gulpPlumber2['default'])(options.plumberOptions)).pipe((0, _gulpChanged2['default'])(options.dest, { extension: '.js' })).pipe((0, _gulpRename2['default'])(function (path) {
					if (path.extname === '.jsx') {
						path.extname = '.js';
					}
				})).pipe(_gulpSourcemaps2['default'].init());

				if (options.coffee) {
					chain = chain.pipe((0, _gulpCoffee2['default'])(options.coffeeOptions).on('error', _gulpUtil2['default'].log));
				}

				chain = chain.pipe((0, _gulpBabel2['default'])(options.compilerOptions));

				if (options.ngAnnotate) {
					chain = chain.pipe((0, _gulpNgAnnotate2['default'])(options.ngAnnotateOptions));
				}

				if (options.uglify) {
					chain = chain.pipe((0, _gulpUglify2['default'])(options.uglifyOptions));
				}

				if (!(0, _lodashIsUndefined2['default'])(options.chmod)) {
					chain = chain.pipe((0, _gulpChmod2['default'])(options.chmod));
				}

				chain = chain.pipe(_gulpSourcemaps2['default'].write('.')).pipe(gulp.dest(options.dest));

				(0, _lodashForEach2['default'])(options.globalBrowserSyncs, function (bs) {
					chain = chain.pipe(bs.stream({ match: '**/*.js' }));
				});

				return chain;
			});
		}
	}]);

	return BabelTask;
})();

module.exports = BabelTask;
module.exports.compilerOptions = defaultCompilerOptions;