'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _toConsumableArray = require('babel-runtime/helpers/to-consumable-array')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _lodashIsArray = require('lodash/isArray');

var _lodashIsArray2 = _interopRequireDefault(_lodashIsArray);

var _lodashIsString = require('lodash/isString');

var _lodashIsString2 = _interopRequireDefault(_lodashIsString);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var _lodashIsBoolean = require('lodash/isBoolean');

var _lodashIsBoolean2 = _interopRequireDefault(_lodashIsBoolean);

var _lodashMerge = require('lodash/merge');

var _lodashMerge2 = _interopRequireDefault(_lodashMerge);

var _expressHistoryApiFallback = require('express-history-api-fallback');

var _expressHistoryApiFallback2 = _interopRequireDefault(_expressHistoryApiFallback);

var _connectHistoryApiFallback = require('connect-history-api-fallback');

var _connectHistoryApiFallback2 = _interopRequireDefault(_connectHistoryApiFallback);

var BrowserSyncTask = (function () {
	function BrowserSyncTask() {
		_classCallCheck(this, BrowserSyncTask);
	}

	_createClass(BrowserSyncTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if ((0, _lodashIsUndefined2['default'])(this.options.config)) {
				throw new Error('BrowserSyncTask: config is missing from configuration!');
			}

			if (!(0, _lodashIsUndefined2['default'])(this.options.historyApiFallback) && this.options.historyApiFallback !== false) {
				this.options.config.server = (0, _lodashMerge2['default'])({}, this.options.config.server);
				this.options.config.server.middleware = (0, _lodashMerge2['default'])([], this.options.config.server.middleware);

				var historyApiFallbackConfig = undefined;
				var useExpress = false;
				if ((0, _lodashIsArray2['default'])(this.options.historyApiFallback)) {
					historyApiFallbackConfig = this.options.historyApiFallback;
					useExpress = true;
				} else if ((0, _lodashIsString2['default'])(this.options.historyApiFallback)) {
					historyApiFallbackConfig = [this.options.historyApiFallback];
					useExpress = true;
				} else if ((0, _lodashIsBoolean2['default'])(this.options.historyApiFallback)) {
					historyApiFallbackConfig = (0, _lodashMerge2['default'])({}, this.options.historyApiFallback);
				} else {
					throw new Error('BrowserSyncTask: historyApiFallback must be an absolute file path string or an Express Response.sendFile arguments array');
				}
				if (useExpress) {
					this.options.config.server.middleware.push(_expressHistoryApiFallback2['default'].apply(undefined, _toConsumableArray(historyApiFallbackConfig)));
				} else {
					this.options.config.server.middleware.push((0, _connectHistoryApiFallback2['default'])(historyApiFallbackConfig));
				}
			}

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var options = this.options;
			gulp.task(options.taskName, options.taskDeps, function () {
				return new _Promise(function (resolve) {
					var bs = options.taskMaker.createBrowserSync(options.taskName);
					return bs.init(options.config, resolve);
				});
			});
		}
	}]);

	return BrowserSyncTask;
})();

module.exports = BrowserSyncTask;