'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _gulpPlumber = require('gulp-plumber');

var _gulpPlumber2 = _interopRequireDefault(_gulpPlumber);

var _gulpCssUsage = require('gulp-css-usage');

var _gulpCssUsage2 = _interopRequireDefault(_gulpCssUsage);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var CssUsageTask = (function () {
	function CssUsageTask() {
		_classCallCheck(this, CssUsageTask);
	}

	_createClass(CssUsageTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if ((0, _lodashIsUndefined2['default'])(this.options.src)) {
				throw new Error('CssUsageTask: src is missing from configuration!');
			}

			if ((0, _lodashIsUndefined2['default'])(this.options.css)) {
				throw new Error('CssUsageTask: css is missing from configuration!');
			}

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var _options = this.options;
			var taskName = _options.taskName;
			var taskDeps = _options.taskDeps;
			var src = _options.src;
			var css = _options.css;
			var babylon = _options.babylon;

			gulp.task(taskName, taskDeps, function () {
				return gulp.src(src).pipe((0, _gulpPlumber2['default'])()).pipe((0, _gulpCssUsage2['default'])({ css: css, babylon: babylon }));
			});
		}
	}]);

	return CssUsageTask;
})();

module.exports = CssUsageTask;