'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _gulpEslint = require('gulp-eslint');

var _gulpEslint2 = _interopRequireDefault(_gulpEslint);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var EslintTask = (function () {
	function EslintTask() {
		_classCallCheck(this, EslintTask);
	}

	_createClass(EslintTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if (this.options.failOnError && this.options.failAfterError) {
				throw new Error('EslintTask: Please choose either failOnError or failAfterError option!');
			}

			if ((0, _lodashIsUndefined2['default'])(this.options.src)) {
				throw new Error('EslintTask: src is missing from configuration!');
			}

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var options = this.options;
			gulp.task(options.taskName, options.taskDeps, function () {

				var chain = gulp.src(options.src).pipe((0, _gulpEslint2['default'])());

				if (options.quiet) {
					chain = chain.pipe(_gulpEslint2['default'].format(function (reports) {
						reports.forEach(function (report) {
							report.messages = report.messages.filter(function (message) {
								return message.fatal || message.severity > 1;
							});
						});
						return '( *** Eslint runs in quite mode *** )';
					}));
				}

				chain = chain.pipe(_gulpEslint2['default'].format());

				if (options.failOnError) {
					chain = chain.pipe(_gulpEslint2['default'].failOnError());
				} else if (options.failAfterError) {
					chain = chain.pipe(_gulpEslint2['default'].failAfterError());
				}

				return chain;
			});
		}
	}]);

	return EslintTask;
})();

module.exports = EslintTask;