'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _gulpHtmlmin = require('gulp-htmlmin');

var _gulpHtmlmin2 = _interopRequireDefault(_gulpHtmlmin);

var _gulpPlumber = require('gulp-plumber');

var _gulpPlumber2 = _interopRequireDefault(_gulpPlumber);

var _gulpChmod = require('gulp-chmod');

var _gulpChmod2 = _interopRequireDefault(_gulpChmod);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var _lodashMerge = require('lodash/merge');

var _lodashMerge2 = _interopRequireDefault(_lodashMerge);

var HtmlMinifyTask = (function () {
	function HtmlMinifyTask() {
		_classCallCheck(this, HtmlMinifyTask);
	}

	_createClass(HtmlMinifyTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if ((0, _lodashIsUndefined2['default'])(this.options.src)) {
				throw new Error('HtmlMinifyTask: src is missing from configuration!');
			}

			if ((0, _lodashIsUndefined2['default'])(this.options.dest)) {
				throw new Error('HtmlMinifyTask: dest is missing from configuration!');
			}

			this.options.minimize = (0, _lodashMerge2['default'])({
				keepClosingSlash: true
			}, this.options.minimize);

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var options = this.options;
			gulp.task(options.taskName, options.taskDeps, function () {
				var chain = gulp.src(options.src).pipe((0, _gulpPlumber2['default'])()).pipe((0, _gulpHtmlmin2['default'])(options.minimize));

				if (!(0, _lodashIsUndefined2['default'])(options.chmod)) {
					chain = chain.pipe((0, _gulpChmod2['default'])(options.chmod));
				}

				chain = chain.pipe(gulp.dest(options.dest));

				return chain;
			});
		}
	}]);

	return HtmlMinifyTask;
})();

module.exports = HtmlMinifyTask;