'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _gulpSourcemaps = require('gulp-sourcemaps');

var _gulpSourcemaps2 = _interopRequireDefault(_gulpSourcemaps);

var _gulpUglify = require('gulp-uglify');

var _gulpUglify2 = _interopRequireDefault(_gulpUglify);

var _gulpPlumber = require('gulp-plumber');

var _gulpPlumber2 = _interopRequireDefault(_gulpPlumber);

var _gulpChmod = require('gulp-chmod');

var _gulpChmod2 = _interopRequireDefault(_gulpChmod);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var _lodashMerge = require('lodash/merge');

var _lodashMerge2 = _interopRequireDefault(_lodashMerge);

var defaultUglifyOptions = {
	mangle: true
};

var MinifyTask = (function () {
	function MinifyTask() {
		_classCallCheck(this, MinifyTask);
	}

	_createClass(MinifyTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if ((0, _lodashIsUndefined2['default'])(this.options.src)) {
				throw new Error('MinifyTask: src is missing from configuration!');
			}

			if ((0, _lodashIsUndefined2['default'])(this.options.dest)) {
				throw new Error('MinifyTask: dest is missing from configuration!');
			}

			this.options.uglifyOptions = (0, _lodashMerge2['default'])({}, defaultUglifyOptions, this.options.uglifyOptions);

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var options = this.options;
			gulp.task(options.taskName, options.taskDeps, function () {
				var chain = gulp.src(options.src).pipe((0, _gulpPlumber2['default'])()).pipe(_gulpSourcemaps2['default'].init({ loadMaps: true })).pipe((0, _gulpUglify2['default'])(options.uglifyOptions)).pipe(_gulpSourcemaps2['default'].write('.'));
				if (!(0, _lodashIsUndefined2['default'])(options.chmod)) {
					chain = chain.pipe((0, _gulpChmod2['default'])(options.chmod));
				}

				chain = chain.pipe(gulp.dest(options.dest));

				return chain;
			});
		}
	}]);

	return MinifyTask;
})();

module.exports = MinifyTask;