'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _gulpPlumber = require('gulp-plumber');

var _gulpPlumber2 = _interopRequireDefault(_gulpPlumber);

var _gulpSass = require('gulp-sass');

var _gulpSass2 = _interopRequireDefault(_gulpSass);

var _gulpSourcemaps = require('gulp-sourcemaps');

var _gulpSourcemaps2 = _interopRequireDefault(_gulpSourcemaps);

var _gulpChmod = require('gulp-chmod');

var _gulpChmod2 = _interopRequireDefault(_gulpChmod);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var _lodashMerge = require('lodash/merge');

var _lodashMerge2 = _interopRequireDefault(_lodashMerge);

var _lodashForEach = require('lodash/forEach');

var _lodashForEach2 = _interopRequireDefault(_lodashForEach);

var SassTask = (function () {
	function SassTask() {
		_classCallCheck(this, SassTask);
	}

	_createClass(SassTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if ((0, _lodashIsUndefined2['default'])(this.options.src)) {
				throw new Error('SassTask: src is missing from configuration!');
			}

			if ((0, _lodashIsUndefined2['default'])(this.options.dest)) {
				throw new Error('SassTask: dest is missing from configuration!');
			}

			if (this.options.notify) {
				this.options.plumberOptions = this.options.defaultErrorHandler;
			}

			this.options.plumberOptions = (0, _lodashMerge2['default'])({}, this.options.plumberOptions);

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var options = this.options;
			gulp.task(options.taskName, options.taskDeps, function () {
				var chain = gulp.src(options.src).pipe((0, _gulpPlumber2['default'])(options.plumberOptions)).pipe(_gulpSourcemaps2['default'].init()).pipe((0, _gulpSass2['default'])(options.config)).pipe(_gulpSourcemaps2['default'].write('.'));
				if (!(0, _lodashIsUndefined2['default'])(options.chmod)) {
					chain = chain.pipe((0, _gulpChmod2['default'])(options.chmod));
				}
				chain = chain.pipe(gulp.dest(options.dest));

				(0, _lodashForEach2['default'])(options.globalBrowserSyncs, function (bs) {
					chain = chain.pipe(bs.stream({ match: '**/*.css' }));
				});

				return chain;
			});
		}
	}]);

	return SassTask;
})();

module.exports = SassTask;