'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _del = require('del');

var _del2 = _interopRequireDefault(_del);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _lodashIsUndefined = require('lodash/isUndefined');

var _lodashIsUndefined2 = _interopRequireDefault(_lodashIsUndefined);

var WatchTask = (function () {
	function WatchTask() {
		_classCallCheck(this, WatchTask);
	}

	_createClass(WatchTask, [{
		key: 'setOptions',
		value: function setOptions(options) {
			this.options = options;

			if ((0, _lodashIsUndefined2['default'])(this.options.src)) {
				throw new Error('WatchTask: src is missing from configuration!');
			}

			if ((0, _lodashIsUndefined2['default'])(this.options.tasks)) {
				throw new Error('WatchTask: Tasks is missing from configuration!');
			}

			return this;
		}
	}, {
		key: 'defineTask',
		value: function defineTask(gulp) {
			var options = this.options;
			var that = this;
			gulp.task(options.taskName, options.taskDeps, function () {
				that.watch(gulp);
			});
		}
	}, {
		key: 'watch',
		value: function watch(gulp) {
			var options = this.options;
			var watcher = gulp.watch(options.src, options.tasks);
			watcher.on('change', function (event) {
				_gulpUtil2['default'].log(_gulpUtil2['default'].colors.magenta('File ' + event.path + ' was ' + event.type + ', running tasks: ' + options.tasks));

				// https://github.com/gulpjs/gulp/blob/master/docs/recipes/handling-the-delete-event-on-watch.md
				if (event.type === 'deleted' && !(0, _lodashIsUndefined2['default'])(options.dest)) {
					var filePathFromSrc = _path2['default'].relative(_path2['default'].resolve(options.src), event.path);
					var destFilePath = _path2['default'].resolve(options.dest, filePathFromSrc);
					_del2['default'].sync(destFilePath);
				}
			});
		}
	}]);

	return WatchTask;
})();

module.exports = WatchTask;